/* WCECompatibleImage.java
   Copyright (C) 2006 Free Software Foundation, Inc.

This file is part of Mysaifu JVM.

Mysaifu JVM is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

Mysaifu JVM is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mysaifu JVM; see the file COPYING.  If not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA.

Linking this library statically or dynamically with other modules is
making a combined work based on this library.  Thus, the terms and
conditions of the GNU General Public License cover the whole
combination.

As a special exception, the copyright holders of this library give you
permission to link this library with independent modules to produce an
executable, regardless of the license terms of these independent
modules, and to copy and distribute the resulting executable under
terms of your choice, provided that you also meet, for each linked
independent module, the terms and conditions of the license of that
module.  An independent module is a module which is not derived from
or based on this library.  If you modify this library, you may extend
this exception to your version of the library, but you are not
obligated to do so.  If you do not wish to do so, delete this
exception statement from your version. */

package gnu.java.awt.peer.wce;

import java.awt.Image;
import java.awt.image.BufferedImage;
import java.util.HashMap;
import java.util.Map;

/**
 * BufferedImageと互換性のあるImage。
 * BufferedImageとネイティブイメージ間のピクセルデータ転送処理を管理する。
 * このインスタンスに対する描画結果は、updateBufferedImage(int, int, int, int)メソッドを呼び出すことで
 * BufferedImageに反映することができる。
 *
 */
public class WCECompatibleImage extends WCEImage {
	/**
	 * WCECompatibleImageと対応するBufferedImageを保持するMap。
	 * BufferedImage のインスタンスをキーにして、WCEDIBSectionImageのインスタンスを入れておく。
	 */
	static Map bufferedImages = new HashMap();

	/**
	 * 関連付けられたBufferedImage。
	 */
	private final BufferedImage image;

	/**
	 * 指定されたBufferedImageと互換性のあるインスタンスを作成する。
	 */
	protected WCECompatibleImage(BufferedImage image) {
		this.image = image;
		setDimension(image.getWidth(), image.getHeight());
		
		// イメージデータをBufferedImageの内容で初期化する
		load();
	}
	
	/**
	 * 指定されたBufferedImageと互換性のあるインスタンスを作成する。
	 * 内部キャッシュを調べ、すでに対応するWCECompatibleImageのインスタンスが生成されていた場合は、
	 * そのインスタンスを返す。
	 */
	public static WCECompatibleImage getInstance(BufferedImage image) {
		synchronized (bufferedImages) {
			Object instance = bufferedImages.get(image);
			if (instance != null) {
				return (WCECompatibleImage) instance;
			}
			// 新規にインスタンスを作成する
			WCECompatibleImage result = new WCECompatibleImage(image);
			bufferedImages.put(image, result);
			return result;
		}
	}
	
	protected int createBitmapHandle(int windowHandle) {
		// ToDo: 最適なフォーマットを持つネイティブイメージを作成する
		return createNativeBitmapHandle(getWidth(), getHeight());
	}
	
	/**
	 * ネイティブビットマップを作成し、そのハンドル(HBITMAP)を返す。
	 */
	private native int createNativeBitmapHandle(int width, int height);

	/**
	 * このインスタンスに関連付けられた BufferedImage を返す。
	 * 返されたBufferedImageのピクセルを直接操作した場合は、
	 * load() を呼び出して内容を再構築する必要がある
	 */
	public BufferedImage getBufferedImage() {
		return this.image;
	}

	/**
	 * 関連付けられたBufferedImageに内容を転送する
	 *
	 * @param	x	転送範囲左上のx座標
	 * @param	y	転送範囲左上のy座標
	 * @param	width	転送範囲の幅
	 * @param	height	転送範囲の高さ
	 */
	public void updateBufferedImage(int x, int y, int width, int height) {
		// ToDo: 高速化する
		BufferedImage image = getBufferedImage();
		int[] pixels = image.getRGB(0,
									0,
									getWidth(),
									getHeight(),
									null,
									0,
									getWidth());
		setNativeData(getBitmapHandle(), pixels);
	}
	
	/**
	 * 指定されたピクセルデータの内容をネイティブデータに設定する。
	 */
	private native void setNativeData(int bitmapHandle, int[] pixels);
	
	/**
	 * 関連付けられたBufferedImage全体の内容をロードする
	 */
	public void load() {
		// 現在の実装では、サイズが変更されてしまうと対応できない
		if (getWidth() != this.image.getWidth()
				|| getHeight() != this.image.getHeight()) {
			throw new IllegalStateException("Image size changed");
		}
		
		int[] pixels = getNativeData(getBitmapHandle());
		BufferedImage image = getBufferedImage();
		image.setRGB(0,
					 0,
					 getWidth(),
					 getHeight(),
					 pixels,
					 0,
					 getWidth());
	}

	/**
	 * ネイティブデータをint[]配列として取得する
	 * 返された int 配列内のデータフォーマットは以下のようになる。
	 *
	 * 00RRGGBB
	 */
	private native int[] getNativeData(int bitmapHandle);

}
